<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { NextStepAlt } from '../../components/common/index.vue';
import { getPageMetadata } from '../../common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';
import { FooterEditLinkMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    NextStepAlt,
  },
  mixins: [FooterEditLinkMixin],
  async validate({ i18n, $contentfulService }: any) {
    if (process.client) {
      return true;
    }

    const availableLanguages =
      await $contentfulService.getContentfulPageAvailableLanguages({
        contentType: CONTENT_TYPES.PAGE,
        slug: 'topics',
        localizationField: 'description',
      });

    return availableLanguages.some((locale) => locale === i18n.locale);
  },
  async asyncData({ i18n }: any) {
    const locale = convertToCaseSensitiveLocale(i18n.locale);

    try {
      const client = getClient();
      const filteredContent = await client.getEntries({
        content_type: CONTENT_TYPES.TOPICS,
        select: 'fields.title, fields.icon, fields.slug',
        order: 'fields.title',
        locale,
      });

      const { items } = await client.getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'topics',
        locale,
      });

      const [page] = items;

      const pageContent = page.fields.pageContent[0].fields;

      const spaceId = page.sys.space.sys.id;
      const entryId = page.sys.id;

      const topics = filteredContent.items
        .filter((item: any) => Boolean(item.fields.icon))
        .map((item: any) => {
          return {
            topic_name: item.fields.title,
            icon: item.fields.icon,
            path: item.fields.slug,
          };
        });

      const seo = page.fields.seoMetadata[0].fields;

      return { topics, pageContent, seo, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).seo || {},
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
});
</script>

<template>
  <SlpContainer class="slp-mt-md-96 slp-mt-32">
    <SlpTypography variant="heading2-bold" tag="h1" class="slp-mb-16">
      {{ pageContent.header }}
    </SlpTypography>
    <SlpTypography variant="body1" tag="p" class="slp-mb-16 slp-mb-md-96">
      {{ pageContent.text }}
    </SlpTypography>
    <div class="card-container" :cols="3">
      <SlpCard100
        v-for="topic in topics"
        :key="topic.topic_name"
        :link="topic.path"
        :data-ga-name="topic.topic_name"
        data-ga-location="body"
        class="card"
      >
        <SlpIcon
          size="md"
          color="slp-surface-300"
          :name="topic.icon"
          variant="marketing"
        />
        <SlpTypography tag="h1" variant="heading5-bold" class="slp-my-16">{{
          topic.topic_name
        }}</SlpTypography>
        <SlpButton variant="tertiary">
          {{ $t('learnMore') }}
          <SlpIcon name="chevron-lg-right" variant="product" />
        </SlpButton>
      </SlpCard100>
    </div>
    <NextStepAlt />
  </SlpContainer>
</template>

<style scoped lang="scss">
.card {
  background-color: $color-surface-800;
  min-height: 250px;
  border-radius: 4px;

  @media (max-width: $breakpoint-md) {
    min-width: 100%;
    min-height: fit-content;
  }

  &:hover {
    background: linear-gradient(
      93.83deg,
      rgba(199, 177, 254, 0.4) 7.27%,
      rgba(255, 212, 216, 0.4) 105.33%
    ) !important;
  }
}
.card-container {
  width: 100%;
  padding: 0;
  display: grid;
  gap: 24px;
  grid-template-columns: 1fr;

  @media (min-width: 350px) {
    grid-template-columns: repeat(2, 1fr);
  }

  @media (min-width: $breakpoint-md) {
    grid-template-columns: repeat(4, 1fr);
  }

  @media (max-width: $breakpoint-md) {
    padding: 0;
  }
}
</style>
